//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"


#property indicator_separate_window
#property indicator_buffers   6
#property indicator_color1    clrBlue
#property indicator_width1    2 
#property indicator_color2    clrRed
#property indicator_width2    2
#property indicator_color3    clrTurquoise
#property indicator_width3    2
#property indicator_color4    clrDarkOrange
#property indicator_width4    2 
#property indicator_color5    clrYellow
#property indicator_width5    2 
#property indicator_color6    clrWhite
#property indicator_width6    2 
#property indicator_maximum   2
#property indicator_minimum   0
#property strict

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_tbiased2,   // Trend biased (extreme) price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased,  // Heiken ashi trend biased price
   pr_hatbiased2  // Heiken ashi trend biased (extreme) price
};
enum enMaTypes
{
   ma_sma,    // Simple moving average
   ma_ema,    // Exponential moving average
   ma_smma,   // Smoothed MA
   ma_lwma,   // Linear weighted MA
   ma_tema    // Triple exponential moving average - TEMA
};

extern ENUM_TIMEFRAMES TimeFrame                     = PERIOD_CURRENT;    // Time frame
extern bool            UseRSI                        = true;              // Use rsi = true or stochastic = false
extern double          Length                        = 10;                // Length 
extern double          Signal                        = 5;                 // Signal period 
extern double          Smooth                        = 5;                 // Smooth period
extern enMaTypes       MaMethod                      = ma_sma;            // Moving average type
extern enPrices        Price                         = pr_close;          // Price
extern double          IndValue                      = 1;                 // Separate window rrow location
extern bool            arrowsVisible                 = false;             // Show arrows?
extern string          arrowsIdentifier              = "abs arrows1";     // Arrows ID
extern bool            arrowsOnNewest                = false;             // Arrows drawn on newst bar of higher time frame bar?
extern double          arrowsUpperGap                = 0.5;               // Arrows Upper Gap
extern double          arrowsLowerGap                = 0.5;               // Arrows lower gap
extern bool            arrowsOnStrTrend              = true;              // Show arrows on a strong trend?
extern color           arrowsOnStrTrendUpColor       = clrLimeGreen;      // Strong trend Up arrow color
extern color           arrowsOnStrTrendDnColor       = clrRed;            // Strong trend Down arrows color
extern int             arrowsOnStrTrendUpCode        = 241;               // Strong trend Up arrow code
extern int             arrowsOnStrTrendDnCode        = 242;               // Strong trend Down arrow code
extern bool            arrowsOnStrTrendUpSize        = 2;                 // Strong trend Up arrow size
extern bool            arrowsOnStrTrendDnSize        = 2;                 // Strong trend Down arrow size
extern bool            arrowsOnWeakTrend             = false;             // Show arrows on weak trend?      
extern color           arrowsOnWeakTrendUpColor      = clrLimeGreen;      // Weak trend Up arrow color
extern color           arrowsOnWeakTrendDnColor      = clrRed;            // Weak trend Down arrows color
extern int             arrowsOnWeakTrendUpCode       = 159;               // Weak trend Up arrow code
extern int             arrowsOnWeakTrendDnCode       = 159;               // Weak trend Down arrow code
extern bool            arrowsOnWeakTrendUpSize       = 2;                 // Weak trend Up arrow size
extern bool            arrowsOnWeakTrendDnSize       = 2;                 // Weak trend Down arrow size  
extern bool            arrowsOnNoTrend               = false;             // Show arrows on no trend?     
extern color           arrowsNoTrendColor            = clrRed;            // No trend arrows color
extern int             arrowsNoTrendCode             = 159;               // No trend arrow code
extern bool            arrowsNoTrendSize             = 2;                 // No trend  arrow size
  
//
//
//
//
//

double SmthBulls[];
double SmthBears[];
double SigBulls[];
double SigBears[];
double Up[];
double Dn[];
double cBulls[];
double cBears[];
double Choppy[];
double NoTrade[];
double trend[];
double count[];

string indicatorFileName;
#define _mtfCall(_buff,_y) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,UseRSI,Length,Signal,Smooth,MaMethod,Price,IndValue,arrowsVisible,arrowsIdentifier,arrowsOnNewest,arrowsUpperGap,arrowsLowerGap,arrowsOnStrTrend,arrowsOnStrTrendUpColor,arrowsOnStrTrendDnColor,arrowsOnStrTrendUpCode,arrowsOnStrTrendDnCode,arrowsOnStrTrendUpSize,arrowsOnStrTrendDnSize,arrowsOnWeakTrend,arrowsOnWeakTrendUpColor,arrowsOnWeakTrendDnColor,arrowsOnWeakTrendUpCode,arrowsOnWeakTrendDnCode,arrowsOnWeakTrendUpSize,arrowsOnWeakTrendDnSize,arrowsOnNoTrend,arrowsNoTrendColor,arrowsNoTrendCode,arrowsNoTrendSize,_buff,_y)

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(12);
   SetIndexBuffer(0,Up);      SetIndexStyle(0,DRAW_ARROW);  SetIndexArrow(0,167); SetIndexLabel(0,"Up");
   SetIndexBuffer(1,Dn);      SetIndexStyle(1,DRAW_ARROW);  SetIndexArrow(1,167); SetIndexLabel(1,"Down");
   SetIndexBuffer(2,cBulls);  SetIndexStyle(2,DRAW_ARROW);  SetIndexArrow(2,167); SetIndexLabel(2,"Bear Market Rally");
   SetIndexBuffer(3,cBears);  SetIndexStyle(3,DRAW_ARROW);  SetIndexArrow(3,167); SetIndexLabel(3,"Correction");
   SetIndexBuffer(4,Choppy);  SetIndexStyle(4,DRAW_ARROW);  SetIndexArrow(4,167); SetIndexLabel(4,"Choppy");
   SetIndexBuffer(5,NoTrade); SetIndexStyle(5,DRAW_ARROW);  SetIndexArrow(5,167); SetIndexLabel(5,"Non Trade");
   SetIndexBuffer(6,SmthBulls); 
   SetIndexBuffer(7,SmthBears);             
   SetIndexBuffer(8,SigBulls);  
   SetIndexBuffer(9,SigBears);  
   SetIndexBuffer(10,trend);
   SetIndexBuffer(11,count);
   
   indicatorFileName = WindowExpertName();
   TimeFrame        = fmax(TimeFrame,_Period); 
    
   IndicatorShortName(timeFrameToString(TimeFrame)+"  AbsoluteStrength Market");
return(0);
}
int deinit()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = fmin(Bars-counted_bars,Bars-1); count[0]=limit;
            if (TimeFrame!=_Period)
            {
               limit = (int)fmax(limit,fmin(Bars-1,_mtfCall(11,0)*TimeFrame/_Period));
               for (i=limit;i>=0 && !_StopFlag; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     Up[i]      = _mtfCall(0,y);
                     Dn[i]      = _mtfCall(1,y);
                     cBulls[i]  = _mtfCall(2,y);
                     cBears[i]  = _mtfCall(3,y);
                     Choppy[i]  = _mtfCall(4,y);
                     NoTrade[i] = _mtfCall(5,y);
               }
            return(0);
            }               

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      if (i<Bars-1)
      {
         double Price1 = getPrice(Price,Open,Close,High,Low,i);
         double Price2 = getPrice(Price,Open,Close,High,Low,i+1);  
         double Bulls  = 0;
         double Bears  = 0; 
      
           if (UseRSI)
           {
              Bulls = 0.5*(fabs(Price1-Price2)+(Price1-Price2));
              Bears = 0.5*(fabs(Price1-Price2)-(Price1-Price2));
            }
           else
           {
              double smax = High[i]; for(int k=1; k<Length && (i+k)>=Bars; k++) smax = fmax(smax,High[i+k]);
              double smin =  Low[i]; for(int k=1; k<Length && (i+k)>=Bars; k++) smin = fmin(smin, Low[i+k]);
              Bulls = Price1 - smin;
              Bears = smax - Price1;
           }
   
           double AvgBulls = iCustomMa(MaMethod,Bulls,       Length,i,0);   
           double AvgBears = iCustomMa(MaMethod,Bears,       Length,i,1);
           SmthBulls[i]    = iCustomMa(MaMethod,AvgBulls,    Smooth,i,2);  
           SmthBears[i]    = iCustomMa(MaMethod,AvgBears,    Smooth,i,3);
           SigBulls[i]     = iCustomMa(MaMethod,SmthBulls[i],Signal,i,4);    
           SigBears[i]     = iCustomMa(MaMethod,SmthBears[i],Signal,i,5); 
           
           trend[i] = 0;
           if (SmthBulls[i] > SigBulls[i] && SmthBulls[i] > SigBears[i] && SmthBears[i] < SigBears[i])  trend[i] = 1;
           if (SmthBulls[i] > SigBulls[i] && SmthBulls[i] < SigBears[i] && SmthBears[i] < SigBears[i])  trend[i] = 2;
           if (SmthBears[i] > SigBears[i] && SmthBears[i] > SigBulls[i] && SmthBulls[i] < SigBulls[i])  trend[i] =-1;
           if (SmthBears[i] > SigBears[i] && SmthBears[i] < SigBulls[i] && SmthBulls[i] < SigBulls[i])  trend[i] =-2;
           if (SmthBears[i] > SigBears[i] && SmthBulls[i] > SigBulls[i])                                trend[i] = 3;
           if (SmthBears[i] < SigBears[i] && SmthBulls[i] < SigBulls[i])                                trend[i] = 4;   
           Up[i]      = EMPTY_VALUE;
           Dn[i]      = EMPTY_VALUE;
           cBulls[i]  = EMPTY_VALUE;
           cBears[i]  = EMPTY_VALUE;
           Choppy[i]  = EMPTY_VALUE;
           NoTrade[i] = EMPTY_VALUE;
           
           if(trend[i] ==  1) Up[i]    = IndValue;
           else
           if(trend[i] == -1) Dn[i]    = IndValue;
           else
           if(trend[i] ==  2) cBulls[i] = IndValue;
           else
           if(trend[i] == -2) cBears[i] = IndValue;
           else
           if(trend[i] ==  3) Choppy[i] = IndValue;
           else
           if(trend[i] ==  4) NoTrade[i] = IndValue;
   
        }
        
        //
        //
        //
        //
        //
            
        if (arrowsVisible)
        {
           ObjectDelete(arrowsIdentifier+":1:"+(string)Time[i]);
           ObjectDelete(arrowsIdentifier+":2:"+(string)Time[i]);
           ObjectDelete(arrowsIdentifier+":3:"+(string)Time[i]);
           string lookFor = arrowsIdentifier+":"+(string)Time[i]; ObjectDelete(lookFor);
           if (i<(Bars-1) && arrowsOnStrTrend && trend[i] != trend[i+1])
           {
              if (trend[i] == 1) drawArrow("1",0.5,i,arrowsOnStrTrendUpColor,arrowsOnStrTrendUpCode,arrowsOnStrTrendUpSize,false);
              if (trend[i] ==-1) drawArrow("1",0.5,i,arrowsOnStrTrendDnColor,arrowsOnStrTrendDnCode,arrowsOnStrTrendDnSize,true);
            }
            if (i<(Bars-1) && arrowsOnWeakTrend && trend[i] != trend[i+1])
            {
                if (trend[i] == 2) drawArrow("2",1,i,arrowsOnWeakTrendUpColor,arrowsOnWeakTrendUpCode,arrowsOnWeakTrendUpSize,false);
                if (trend[i] ==-2) drawArrow("2",1,i,arrowsOnWeakTrendDnColor,arrowsOnWeakTrendDnCode,arrowsOnWeakTrendDnSize,true);
             }
             if (i<(Bars-1) && arrowsOnNoTrend && trend[i] != trend[i+1])
             {
                if (trend[i] == 3) drawArrow("3",1,i,arrowsNoTrendColor,arrowsNoTrendCode,arrowsNoTrendSize,false);
                if (trend[i] == 4) drawArrow("3",1,i,arrowsNoTrendColor,arrowsNoTrendCode,arrowsNoTrendSize,true);
              }
              
            }
   }
return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

#define _maInstances 6
#define _maWorkBufferx1 1*_maInstances
#define _maWorkBufferx3 3*_maInstances

double iCustomMa(int mode, double price, double length, int r, int instanceNo=0)
{
   int bars = Bars; r = bars-r-1;
   switch (mode)
   {
      case ma_sma   : return(iSma(price,(int)length,r,bars,instanceNo));
      case ma_ema   : return(iEma(price,length,r,bars,instanceNo));
      case ma_smma  : return(iSmma(price,(int)length,r,bars,instanceNo));
      case ma_lwma  : return(iLwma(price,(int)length,r,bars,instanceNo));
      case ma_tema  : return(iTema(price,(int)length,r,bars,instanceNo));
      default       : return(price);
   }
}

//
//
//
//
//

double workSma[][_maWorkBufferx1];
double iSma(double price, int period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= _bars) ArrayResize(workSma,_bars);

   workSma[r][instanceNo] = price;
   double avg = price; int k=1; for(; k<period && (r-k)>=0; k++) avg += workSma[r-k][instanceNo];  
   return(avg/k);
}

//
//
//
//
//

double workEma[][_maWorkBufferx1];
double iEma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= _bars) ArrayResize(workEma,_bars);

   workEma[r][instanceNo] = price;
   if (r>0 && period>1)
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+(2.0/(1.0+period))*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//
//
//
//
//

double workSmma[][_maWorkBufferx1];
double iSmma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workSmma,0)!= _bars) ArrayResize(workSmma,_bars);

   workSmma[r][instanceNo] = price;
   if (r>1 && period>1)
          workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}

//
//
//
//
//

double workLwma[][_maWorkBufferx1];
double iLwma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workLwma,0)!= _bars) ArrayResize(workLwma,_bars);
   
   workLwma[r][instanceNo] = price; if (period<=1) return(price);
      double sumw = period;
      double sum  = period*price;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*workLwma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}

//
//
//
//
//

double workTema[][_maWorkBufferx3];
#define _tema1 0
#define _tema2 1
#define _tema3 2

double iTema(double price, double period, int r, int bars, int instanceNo=0)
{
   if (ArrayRange(workTema,0)!= bars) ArrayResize(workTema,bars); instanceNo*=3;

   //
   //
   //
   //
   //
      
   workTema[r][_tema1+instanceNo] = price;
   workTema[r][_tema2+instanceNo] = price;
   workTema[r][_tema3+instanceNo] = price;
   if (r>0 && period>1)
   {
      double alpha = 2.0 / (1.0+period);
          workTema[r][_tema1+instanceNo] = workTema[r-1][_tema1+instanceNo]+alpha*(price                         -workTema[r-1][_tema1+instanceNo]);
          workTema[r][_tema2+instanceNo] = workTema[r-1][_tema2+instanceNo]+alpha*(workTema[r][_tema1+instanceNo]-workTema[r-1][_tema2+instanceNo]);
          workTema[r][_tema3+instanceNo] = workTema[r-1][_tema3+instanceNo]+alpha*(workTema[r][_tema2+instanceNo]-workTema[r-1][_tema3+instanceNo]); }
   return(workTema[r][_tema3+instanceNo]+3.0*(workTema[r][_tema1+instanceNo]-workTema[r][_tema2+instanceNo]));
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

#define priceInstances 1
double workHa[][priceInstances*4];
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (tprice>=pr_haclose)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars); instanceNo*=4;
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (tprice)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
            case pr_hatbiased2:
               if (haClose>haOpen)  return(haHigh);
               if (haClose<haOpen)  return(haLow);
                                    return(haClose);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
      case pr_tbiased2:   
               if (close[i]>open[i]) return(high[i]);
               if (close[i]<open[i]) return(low[i]);
                                     return(close[i]);        
   }
   return(0);
}   

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor, int theCode, int theWidth, bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+(string)Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      int add = 0; if (!arrowsOnNewest) add = _Period*60-1;
      ObjectCreate(name,OBJ_ARROW,0,Time[i]+add,0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}



